diff --git a/libr/bin/p/bin_dex.c b/libr/bin/p/bin_dex.c
index 3201d5b43b4..3fca1d63b16 100644
--- a/libr/bin/p/bin_dex.c
+++ b/libr/bin/p/bin_dex.c
@@ -56,12 +56,16 @@ static char *getstr(RBinDexObj *bin, int idx) {
 	if (!len || len >= bin->size) {
 		return NULL;
 	}
+	if (uleblen + bin->strings[idx] >= bin->strings + bin->header.strings_size) {
+		return NULL;
+	}
 	char* ptr = (char*) r_buf_get_at (bin->b, bin->strings[idx] + uleblen, NULL);
 	if (!ptr) {
 		return NULL;
 	}
-	if (len != strlen (ptr)) {
-		eprintf ("WARNING: Invalid string for index %d\n", idx);
+
+	if (len != r_utf8_strlen (ptr)) {
+		eprintf ("WARNING: Invalid string for index %d %d!=%d\n", idx, len, strlen(ptr));
 		return NULL;
 	}
 	return ptr;
